# Muesli is a Multi Use Embeddable Scripting Language Implementation.

## Introduction

Muesli is a scripting language implemented in Go, that has a simple command 
chain based TCL or shell like syntax but with rich semantics. Unlike TCL
or shels, all muelsi values are typed, and many types are supported, 
not just string values. Additionaly, if so desired, every symbol used in the 
syntax can be replaced by a key word, leading to a native language programming 
feel.

## Syntax

A Muesli program consists of blocks and/or chains, separated by newlines or 
periods. A chain consists of one or more commands, linked together by operators.

Blocks consist of chains grouped together in blocks between braces {}. The 
commands in a block are not executed immediately but stored.

A single chain can be placed in parenthesis (), where the return value of the 
chain will be subsituted.  Lists are formed by placing their contents 
between brackets [].

Every command has a return value, which can be of any type, and not just a 
number like in most shells. Furthermore commands have input and output, which 
default to stdin and stdout, but can be redirected or reconfigured. 

There are three types of commands, namely direct commands indirect commmands
and literal commands. A direct command starts with a name, and is followed by 
any number of parameters. Parameters may be which may be blocks, parenthesis, 
lists, names or literals, or values. An indirect command starts with a 
substitution followed by parameters. A literal command is simply a numeric,
string, boolean or nil literal that evaluates to itself.

The language itself has no control statements, such as if, or for, 
these are implemented as commands in stead.

Muesly supports several kinds of values, namely: 
- Integers
- Floats 
- Strings between "double quotes"
- The booleans !true and !false
- The nil value !nil
- Words, which are simple runs of alphanumercial characters starting with a 
  lower case lettter, such as foo
- Types which are runs of alphanumerical characters starting with an upper 
  case letter, such as Foo.



